#include <stdlib.h>
#include <stdio.h>

#include "exercicios.h"


// Verificar se a lista  L está ordenada (crescente ou decrescente)

int eh_ordenada(LISTA_ESTATICA *l) {
   int i, k = tamanho_lista_estatica(l);
   if ( k <= 1 ) return 1;


   for (i = 1; i < k; i++)
   {
     if ((l->vetor[i])->chave < (l->vetor[i-1])->chave)
        break;
   }
   if (i == k) return 1;

   for (i = 1; i < k; i++)
   {
     if ((l->vetor[i])->chave > (l->vetor[i-1])->chave)
        return 0;
   }
   return 1;

}


// fazer a copia de L1 em outra lista L2
LISTA_ESTATICA *duplica_lista_estatica(LISTA_ESTATICA *l1) {
LISTA_ESTATICA *l2 = criar_lista_estatica();
int i, k = tamanho_lista_estatica(l1);

   for (i = 0; i < k; i++) {
      ITEM *it = criar_item((l1->vetor[i])->chave, (l1->vetor[i])->valor);
      inserir_lista_estatica(l2, it);
   }
   return l2;
}

// fazer a copia de L1 em outra L2 eliminando repetidos
// fazer a copia de L1 em outra lista L2
LISTA_ESTATICA *duplica_sem_repetidos_lista_estatica(LISTA_ESTATICA *l1) {
LISTA_ESTATICA *l2 = criar_lista_estatica();
int i, k = tamanho_lista_estatica(l1);

   for (i = 0; i < k; i++) {
      if (buscar_lista_estatica(l2, (l1->vetor[i])->chave) == NULL) {
      	ITEM *it = criar_item((l1->vetor[i])->chave, (l1->vetor[i])->valor);
      	inserir_lista_estatica(l2, it);
      }
   }
   return l2;
}


// inverter L1 em outra lista L2
LISTA_ESTATICA *inverte_copia_lista_estatica(LISTA_ESTATICA *l1) {
LISTA_ESTATICA *l2 = criar_lista_estatica();
int i, k = tamanho_lista_estatica(l1);

   for (i = k - 1; i >= 0; i--) {
      ITEM *it = criar_item((l1->vetor[i])->chave, (l1->vetor[i])->valor);
      inserir_lista_estatica(l2, it);
   }
   return l2;
}


// inverter L1
void inverte_lista_estatica(LISTA_ESTATICA *l1) {
int i, k = tamanho_lista_estatica(l1), j;

   for (i = 0, j = k-1; i <j; i++, j--) {
      ITEM *temp = l1->vetor[i];
      l1->vetor[i] = l1->vetor[j];
      l1->vetor[j] = temp;
   }
}
