/* 
 * File:   main.c
 * Author: paulovich
 *
 * Created on August 8, 2016, 8:35 AM
 */

#include <stdio.h>
#include <stdlib.h>

#include "lista_estatica.h"
#include "exercicios.h"
/*
 * 
 */
int main(int argc, char** argv) {  
  LISTA_ESTATICA *lista = criar_lista_estatica();
  LISTA_ESTATICA *lista2 = NULL, *lista3 = NULL, *lista4 = NULL;  

  for(int i=0; i < 10; i++) {
    ITEM *item = criar_item(i,i);
    inserir_lista_estatica(lista, item);
  }
  inserir_lista_estatica(lista, criar_item(5,-10));
  
  
  imprimir_item(buscar_lista_estatica(lista, 5));
  
  printf("\n====\n");
  
  imprimir_lista_estatica(lista);

  printf("Lista%sestah ordenada\n", eh_ordenada(lista) ? " " : " nao ");

  lista2 = duplica_lista_estatica(lista);
  lista3 = duplica_sem_repetidos_lista_estatica(lista);
  lista4 = inverte_copia_lista_estatica(lista);

  apagar_lista_estatica(&lista);

  imprimir_lista_estatica(lista2);
  imprimir_lista_estatica(lista3);
  imprimir_lista_estatica(lista4);

  inverte_lista_estatica(lista4);
  imprimir_lista_estatica(lista4);

  apagar_lista_estatica(&lista2);
  apagar_lista_estatica(&lista3);
  apagar_lista_estatica(&lista4);

  return (EXIT_SUCCESS);
}

