/* 
 * File:   lista_estatica.h
 * Author: paulovich
 *
 * Created on August 8, 2016, 8:36 AM
 */

#ifndef LISTA_ESTATICA_H
#define	LISTA_ESTATICA_H

#include "item.h"

#define	TAM	100

struct lista_estatica {
  ITEM *vetor[TAM];
  int fim;
};

typedef struct lista_estatica LISTA_ESTATICA;

LISTA_ESTATICA *criar_lista_estatica();
void apagar_lista_estatica(LISTA_ESTATICA **lista);

int inserir_lista_estatica(LISTA_ESTATICA *lista, ITEM *item);
ITEM *buscar_lista_estatica(LISTA_ESTATICA *lista, int chave);
int remover_lista_estatica(LISTA_ESTATICA *lista, int chave);

int cheia_lista_estatica(LISTA_ESTATICA *lista);
int vazia_lista_estatica(LISTA_ESTATICA *lista);
void imprimir_lista_estatica(LISTA_ESTATICA *lista);
int tamanho_lista_estatica(LISTA_ESTATICA *lista);

#endif	/* LISTA_ESTATICA_H */

